/* sudoku-view.c generated by valac 0.48.3, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include "libsudoku.h"
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <pango/pangocairo.h>
#include <glib/gi18n-lib.h>

#define TYPE_SUDOKU_CELL_VIEW (sudoku_cell_view_get_type ())
#define SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellView))
#define SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))
#define IS_SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL_VIEW))
#define IS_SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL_VIEW))
#define SUDOKU_CELL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))

typedef struct _SudokuCellView SudokuCellView;
typedef struct _SudokuCellViewClass SudokuCellViewClass;
typedef struct _SudokuCellViewPrivate SudokuCellViewPrivate;

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
enum  {
	SUDOKU_CELL_VIEW_0_PROPERTY,
	SUDOKU_CELL_VIEW_VALUE_PROPERTY,
	SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_VIEW_SELECTED_PROPERTY,
	SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY,
	SUDOKU_CELL_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_view_properties[SUDOKU_CELL_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuCellView {
	GtkDrawingArea parent_instance;
	SudokuCellViewPrivate * priv;
};

struct _SudokuCellViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _SudokuCellViewPrivate {
	PangoLayout* layout;
	gdouble size_ratio;
	GtkPopover* popover;
	GtkPopover* earmark_popover;
	SudokuGame* game;
	gint row;
	gint col;
	gboolean _show_possibilities;
	gboolean _show_warnings;
	gboolean _selected;
	GdkRGBA _background_color;
	NumberPicker* number_picker;
	NumberPicker* earmark_picker;
	GtkEventControllerKey* key_controller;
};

struct _SudokuView {
	GtkAspectFrame parent_instance;
	SudokuViewPrivate * priv;
	SudokuGame* game;
};

struct _SudokuViewClass {
	GtkAspectFrameClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuCellView** cells;
	gint cells_length1;
	gint cells_length2;
	gboolean previous_board_broken_state;
	GtkOverlay* overlay;
	GtkDrawingArea* drawing;
	GtkGrid* grid;
	gint selected_row;
	gint selected_col;
	gboolean _show_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
};

struct _Block7Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	gint cell_row;
	gint cell_col;
};

static gint SudokuCellView_private_offset;
static gpointer sudoku_cell_view_parent_class = NULL;
static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

GType sudoku_cell_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCellView, g_object_unref)
GType number_picker_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
SudokuCellView* sudoku_cell_view_new (gint row,
                                      gint col,
                                      SudokuGame* * game);
SudokuCellView* sudoku_cell_view_construct (GType object_type,
                                            gint row,
                                            gint col,
                                            SudokuGame* * game);
static inline void sudoku_cell_view_init_keyboard (SudokuCellView* self);
void sudoku_cell_view_set_value (SudokuCellView* self,
                                 gint value);
gboolean sudoku_cell_view_get_is_fixed (SudokuCellView* self);
static gboolean sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                                        GtkWidget* widget,
                                        GdkEventFocus* event);
static gboolean _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self);
void sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                       gint row,
                                       gint col,
                                       gint old_val,
                                       gint new_val);
static void _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                                 gint row,
                                                                 gint col,
                                                                 gint old_val,
                                                                 gint new_val,
                                                                 gpointer self);
static gboolean sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                                   GdkEventButton* event);
void sudoku_cell_view_hide_both_popovers (SudokuCellView* self);
static void sudoku_cell_view_show_earmark_picker (SudokuCellView* self);
static void sudoku_cell_view_show_number_picker (SudokuCellView* self);
static void sudoku_cell_view_create_earmark_picker (SudokuCellView* self);
NumberPicker* number_picker_new (SudokuBoard* * board,
                                 gboolean earmark);
NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard* * board,
                                       gboolean earmark);
static void __lambda7_ (SudokuCellView* self,
                 gint number,
                 gboolean state);
gint sudoku_cell_view_get_value (SudokuCellView* self);
static void ___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda8_ (SudokuCellView* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
static void __lambda9_ (SudokuCellView* self);
static void sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                       GtkPopover* * popover);
static void ___lambda9__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean __lambda10_ (SudokuCellView* self);
static gboolean ___lambda10__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self);
static void __lambda11_ (SudokuCellView* self);
static void ___lambda11__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean __lambda12_ (SudokuCellView* self);
static gboolean ___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self);
static gint sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                      const gchar* key_name);
static inline gboolean sudoku_cell_view_on_key_pressed (SudokuCellView* self,
                                          GtkEventControllerKey* _key_controller,
                                          guint keyval,
                                          guint keycode,
                                          GdkModifierType state);
static gboolean _sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                guint keyval,
                                                                                guint keycode,
                                                                                GdkModifierType state,
                                                                                gpointer self);
gboolean number_picker_set_earmark (NumberPicker* self,
                                    gint row,
                                    gint col,
                                    gint index,
                                    gboolean state);
static gboolean sudoku_cell_view_real_draw (GtkWidget* base,
                                     cairo_t* c);
void sudoku_cell_view_set_background_color (SudokuCellView* self,
                                            GdkRGBA * value);
void sudoku_cell_view_clear (SudokuCellView* self);
gboolean sudoku_cell_view_get_show_possibilities (SudokuCellView* self);
void sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                              gboolean value);
gboolean sudoku_cell_view_get_show_warnings (SudokuCellView* self);
void sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                         gboolean value);
gboolean sudoku_cell_view_get_selected (SudokuCellView* self);
void sudoku_cell_view_set_selected (SudokuCellView* self,
                                    gboolean value);
void sudoku_cell_view_get_background_color (SudokuCellView* self,
                                            GdkRGBA * result);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static void sudoku_cell_view_finalize (GObject * obj);
static GType sudoku_cell_view_get_type_once (void);
static void _vala_sudoku_cell_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_sudoku_cell_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
GType sudoku_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
SudokuView* sudoku_view_new (SudokuGame* game);
SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean sudoku_view_draw_board (SudokuView* self,
                                 cairo_t* c);
static gboolean _sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                                  cairo_t* cr,
                                                  gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean ________lambda13_ (Block8Data* _data8_);
static gboolean _________lambda13__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                       GdkEventFocus* event,
                                                       gpointer self);
static void ________lambda14_ (Block8Data* _data8_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda14__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
void sudoku_view_clear (SudokuView* self);
void sudoku_view_hide_popovers (SudokuView* self);
gboolean sudoku_view_get_show_warnings (SudokuView* self);
void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
gboolean sudoku_view_get_show_possibilities (SudokuView* self);
void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
gboolean sudoku_view_get_highlighter (SudokuView* self);
void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const GdkRGBA selected_bg_color = {0.7, 0.8, 0.9};
const GdkRGBA fixed_cell_color = {0.8, 0.8, 0.8, (gdouble) 0};
const GdkRGBA free_cell_color = {1.0, 1.0, 1.0, 1.0};
const GdkRGBA highlight_color = {0.93, 0.93, 0.93, (gdouble) 0};

static inline gpointer
sudoku_cell_view_get_instance_private (SudokuCellView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCellView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self)
{
	gboolean result;
	result = sudoku_cell_view_focus_out_cb ((SudokuCellView*) self, _sender, event);
	return result;
}

static void
_sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self)
{
	sudoku_cell_view_cell_changed_cb ((SudokuCellView*) self, row, col, old_val, new_val);
}

SudokuCellView*
sudoku_cell_view_construct (GType object_type,
                            gint row,
                            gint col,
                            SudokuGame* * game)
{
	SudokuCellView * self = NULL;
	SudokuGame* _tmp0_;
	GtkStyle* _tmp1_;
	GtkStyle* _tmp2_;
	PangoFontDescription* _tmp3_;
	SudokuBoard* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
	g_return_val_if_fail (*game != NULL, NULL);
	self = (SudokuCellView*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (*game);
	_g_object_unref0 (self->priv->game);
	self->priv->game = _tmp0_;
	self->priv->row = row;
	self->priv->col = col;
	sudoku_cell_view_init_keyboard (self);
	_tmp1_ = gtk_widget_get_style ((GtkWidget*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_->font_desc;
	pango_font_description_set_size (_tmp3_, PANGO_SCALE * 13);
	_tmp4_ = (*game)->board;
	sudoku_cell_view_set_value (self, sudoku_board_get (_tmp4_, row, col));
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
	gtk_widget_set_events ((GtkWidget*) self, ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_KEY_PRESS_MASK);
	_tmp6_ = sudoku_cell_view_get_is_fixed (self);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		GameMode _tmp8_;
		_tmp8_ = (*game)->mode;
		_tmp5_ = _tmp8_ == GAME_MODE_PLAY;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		return self;
	}
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event, self, 0);
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed, self, 0);
	return self;
}

SudokuCellView*
sudoku_cell_view_new (gint row,
                      gint col,
                      SudokuGame* * game)
{
	return sudoku_cell_view_construct (TYPE_SUDOKU_CELL_VIEW, row, col, game);
}

static gboolean
sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                          GdkEventButton* event)
{
	SudokuCellView * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
	GameMode _tmp5_;
	gboolean _tmp12_ = FALSE;
	GtkPopover* _tmp13_;
	gboolean result = FALSE;
	self = (SudokuCellView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->button != ((guint) 1)) {
		_tmp0_ = event->button != ((guint) 3);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	g_object_get ((GtkWidget*) self, "is-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		gtk_widget_grab_focus ((GtkWidget*) self);
	}
	_tmp4_ = self->priv->game;
	_tmp5_ = _tmp4_->mode;
	if (_tmp5_ == GAME_MODE_PLAY) {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = sudoku_cell_view_get_is_fixed (self);
		_tmp8_ = _tmp7_;
		if (_tmp8_) {
			_tmp6_ = TRUE;
		} else {
			SudokuGame* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			_tmp9_ = self->priv->game;
			_tmp10_ = sudoku_game_get_paused (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp6_ = _tmp11_;
		}
		_tmp3_ = _tmp6_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp13_ = self->priv->popover;
	if (_tmp13_ != NULL) {
		_tmp12_ = TRUE;
	} else {
		GtkPopover* _tmp14_;
		_tmp14_ = self->priv->earmark_popover;
		_tmp12_ = _tmp14_ != NULL;
	}
	if (_tmp12_) {
		sudoku_cell_view_hide_both_popovers (self);
		result = FALSE;
		return result;
	}
	if (event->button == ((guint) 1)) {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		if (!self->priv->_show_possibilities) {
			GdkModifierType _tmp17_;
			_tmp17_ = event->state;
			_tmp16_ = (_tmp17_ & GDK_CONTROL_MASK) > 0;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			SudokuGame* _tmp18_;
			GameMode _tmp19_;
			_tmp18_ = self->priv->game;
			_tmp19_ = _tmp18_->mode;
			_tmp15_ = _tmp19_ == GAME_MODE_PLAY;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			sudoku_cell_view_show_earmark_picker (self);
		} else {
			sudoku_cell_view_show_number_picker (self);
		}
	} else {
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		if (!self->priv->_show_possibilities) {
			_tmp21_ = event->button == ((guint) 3);
		} else {
			_tmp21_ = FALSE;
		}
		if (_tmp21_) {
			SudokuGame* _tmp22_;
			GameMode _tmp23_;
			_tmp22_ = self->priv->game;
			_tmp23_ = _tmp22_->mode;
			_tmp20_ = _tmp23_ == GAME_MODE_PLAY;
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			sudoku_cell_view_show_earmark_picker (self);
		}
	}
	result = FALSE;
	return result;
}

static void
__lambda7_ (SudokuCellView* self,
            gint number,
            gboolean state)
{
	SudokuGame* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	if (state) {
		SudokuGame* _tmp0_;
		_tmp0_ = self->priv->game;
		sudoku_game_enable_earmark (_tmp0_, self->priv->row, self->priv->col, number);
	} else {
		SudokuGame* _tmp1_;
		_tmp1_ = self->priv->game;
		sudoku_game_disable_earmark (_tmp1_, self->priv->row, self->priv->col, number);
	}
	_tmp2_ = self->priv->game;
	_tmp3_ = sudoku_cell_view_get_value (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = sudoku_cell_view_get_value (self);
	_tmp6_ = _tmp5_;
	g_signal_emit_by_name (_tmp2_, "cell-changed", self->priv->row, self->priv->col, _tmp4_, _tmp6_);
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
	__lambda7_ ((SudokuCellView*) self, number, active);
}

static void
sudoku_cell_view_create_earmark_picker (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	NumberPicker* _tmp2_;
	NumberPicker* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = number_picker_new (&_tmp0_->board, TRUE);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->earmark_picker);
	self->priv->earmark_picker = _tmp1_;
	_tmp2_ = self->priv->earmark_picker;
	g_signal_connect_object (_tmp2_, "earmark-state-changed", (GCallback) ___lambda7__number_picker_earmark_state_changed, self, 0);
	_tmp3_ = self->priv->earmark_picker;
	number_picker_set_earmarks (_tmp3_, self->priv->row, self->priv->col);
}

static void
__lambda8_ (SudokuCellView* self,
            NumberPicker* o,
            gint number)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	GtkPopover* _tmp2_;
	g_return_if_fail (o != NULL);
	sudoku_cell_view_set_value (self, number);
	if (number == 0) {
		g_object_notify ((GObject*) self, "value");
	}
	_tmp0_ = self->priv->game;
	_tmp1_ = _tmp0_->board;
	sudoku_board_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
	_tmp2_ = self->priv->popover;
	gtk_widget_hide ((GtkWidget*) _tmp2_);
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
	__lambda8_ ((SudokuCellView*) self, _sender, number);
}

static void
__lambda9_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->popover;
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		sudoku_cell_view_destroy_popover (self, &self->priv->popover);
	}
}

static void
___lambda9__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda9_ ((SudokuCellView*) self);
}

static gboolean
__lambda10_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->popover;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	result = TRUE;
	return result;
}

static gboolean
___lambda10__gtk_widget_focus_out_event (GtkWidget* _sender,
                                         GdkEventFocus* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda10_ ((SudokuCellView*) self);
	return result;
}

static void
sudoku_cell_view_show_number_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	SudokuGame* _tmp2_;
	NumberPicker* _tmp3_;
	NumberPicker* _tmp4_;
	NumberPicker* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
	NumberPicker* _tmp10_;
	GtkPopover* _tmp11_;
	GtkPopover* _tmp12_;
	GtkPopover* _tmp13_;
	GtkPopover* _tmp14_;
	GtkPopover* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->earmark_popover;
	if (_tmp0_ != NULL) {
		GtkPopover* _tmp1_;
		_tmp1_ = self->priv->earmark_popover;
		gtk_widget_hide ((GtkWidget*) _tmp1_);
	}
	_tmp2_ = self->priv->game;
	_tmp3_ = number_picker_new (&_tmp2_->board, FALSE);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->number_picker);
	self->priv->number_picker = _tmp3_;
	_tmp4_ = self->priv->number_picker;
	g_signal_connect_object (_tmp4_, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, self, 0);
	_tmp5_ = self->priv->number_picker;
	_tmp6_ = sudoku_cell_view_get_value (self);
	_tmp7_ = _tmp6_;
	number_picker_set_clear_button_visibility (_tmp5_, _tmp7_ != 0);
	_tmp8_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->popover);
	self->priv->popover = _tmp8_;
	_tmp9_ = self->priv->popover;
	_tmp10_ = self->priv->number_picker;
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->popover;
	gtk_popover_set_modal (_tmp11_, FALSE);
	_tmp12_ = self->priv->popover;
	gtk_popover_set_position (_tmp12_, GTK_POS_BOTTOM);
	_tmp13_ = self->priv->popover;
	g_signal_connect_object ((GObject*) _tmp13_, "notify::visible", (GCallback) ___lambda9__g_object_notify, self, 0);
	_tmp14_ = self->priv->popover;
	g_signal_connect_object ((GtkWidget*) _tmp14_, "focus-out-event", (GCallback) ___lambda10__gtk_widget_focus_out_event, self, 0);
	_tmp15_ = self->priv->popover;
	gtk_widget_show ((GtkWidget*) _tmp15_);
}

static void
__lambda11_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->earmark_popover;
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		sudoku_cell_view_destroy_popover (self, &self->priv->earmark_popover);
	}
}

static void
___lambda11__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda11_ ((SudokuCellView*) self);
}

static gboolean
__lambda12_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->earmark_popover;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	result = TRUE;
	return result;
}

static gboolean
___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                         GdkEventFocus* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda12_ ((SudokuCellView*) self);
	return result;
}

static void
sudoku_cell_view_show_earmark_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	NumberPicker* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GtkPopover* _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->popover;
	if (_tmp0_ != NULL) {
		GtkPopover* _tmp1_;
		_tmp1_ = self->priv->popover;
		gtk_widget_hide ((GtkWidget*) _tmp1_);
	}
	sudoku_cell_view_create_earmark_picker (self);
	_tmp2_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->earmark_popover);
	self->priv->earmark_popover = _tmp2_;
	_tmp3_ = self->priv->earmark_popover;
	_tmp4_ = self->priv->earmark_picker;
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = self->priv->earmark_popover;
	gtk_popover_set_modal (_tmp5_, FALSE);
	_tmp6_ = self->priv->earmark_popover;
	gtk_popover_set_position (_tmp6_, GTK_POS_BOTTOM);
	_tmp7_ = self->priv->earmark_popover;
	g_signal_connect_object ((GObject*) _tmp7_, "notify::visible", (GCallback) ___lambda11__g_object_notify, self, 0);
	_tmp8_ = self->priv->earmark_popover;
	g_signal_connect_object ((GtkWidget*) _tmp8_, "focus-out-event", (GCallback) ___lambda12__gtk_widget_focus_out_event, self, 0);
	_tmp9_ = self->priv->earmark_popover;
	gtk_widget_show ((GtkWidget*) _tmp9_);
}

static void
sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                  GtkPopover* * popover)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (*popover != NULL);
	if ((*popover) != NULL) {
		gtk_widget_destroy ((GtkWidget*) (*popover));
		_g_object_unref0 (*popover);
		*popover = NULL;
	}
}

void
sudoku_cell_view_hide_both_popovers (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->popover;
	if (_tmp0_ != NULL) {
		GtkPopover* _tmp1_;
		_tmp1_ = self->priv->popover;
		gtk_widget_hide ((GtkWidget*) _tmp1_);
	}
	_tmp2_ = self->priv->earmark_popover;
	if (_tmp2_ != NULL) {
		GtkPopover* _tmp3_;
		_tmp3_ = self->priv->earmark_popover;
		gtk_widget_hide ((GtkWidget*) _tmp3_);
	}
}

static gboolean
sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                               GtkWidget* widget,
                               GdkEventFocus* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	sudoku_cell_view_hide_both_popovers (self);
	result = FALSE;
	return result;
}

static gint
sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                 const gchar* key_name)
{
	gboolean _tmp0_ = FALSE;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (key_name != NULL, 0);
	if (g_strcmp0 (key_name, "KP_0") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (key_name, "0") == 0;
	}
	if (_tmp0_) {
		result = 0;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_1") == 0) {
		result = 1;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_2") == 0) {
		result = 2;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_3") == 0) {
		result = 3;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_4") == 0) {
		result = 4;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_5") == 0) {
		result = 5;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_6") == 0) {
		result = 6;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_7") == 0) {
		result = 7;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_8") == 0) {
		result = 8;
		return result;
	}
	if (g_strcmp0 (key_name, "KP_9") == 0) {
		result = 9;
		return result;
	}
	result = -1;
	return result;
}

static gboolean
_sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                       guint keyval,
                                                                       guint keycode,
                                                                       GdkModifierType state,
                                                                       gpointer self)
{
	gboolean result;
	result = sudoku_cell_view_on_key_pressed ((SudokuCellView*) self, _sender, keyval, keycode, state);
	return result;
}

static inline void
sudoku_cell_view_init_keyboard (SudokuCellView* self)
{
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
	_g_object_unref0 (self->priv->key_controller);
	self->priv->key_controller = _tmp0_;
	_tmp1_ = self->priv->key_controller;
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _sudoku_cell_view_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
}

static inline gboolean
sudoku_cell_view_on_key_pressed (SudokuCellView* self,
                                 GtkEventControllerKey* _key_controller,
                                 guint keyval,
                                 guint keycode,
                                 GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	gchar* k_name = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gint k_no = 0;
	const gchar* _tmp11_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	const gchar* _tmp33_;
	const gchar* _tmp38_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (_key_controller != NULL, FALSE);
	_tmp1_ = self->priv->game;
	_tmp2_ = _tmp1_->mode;
	if (_tmp2_ == GAME_MODE_PLAY) {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = sudoku_cell_view_get_is_fixed (self);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			_tmp3_ = TRUE;
		} else {
			SudokuGame* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
			_tmp6_ = self->priv->game;
			_tmp7_ = sudoku_game_get_paused (_tmp6_);
			_tmp8_ = _tmp7_;
			_tmp3_ = _tmp8_;
		}
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp9_ = gdk_keyval_name (keyval);
	_tmp10_ = g_strdup (_tmp9_);
	k_name = _tmp10_;
	_tmp11_ = k_name;
	k_no = atoi (_tmp11_);
	if (k_no == 0) {
		const gchar* _tmp12_;
		_tmp12_ = k_name;
		k_no = sudoku_cell_view_key_map_keypad (self, _tmp12_);
	}
	if (k_no >= 1) {
		_tmp13_ = k_no <= 9;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GtkPopover* _tmp16_;
		gboolean want_earmark = FALSE;
		gboolean _tmp18_ = FALSE;
		_tmp16_ = self->priv->earmark_popover;
		if (_tmp16_ != NULL) {
			GtkPopover* _tmp17_;
			_tmp17_ = self->priv->earmark_popover;
			_tmp15_ = gtk_widget_is_visible ((GtkWidget*) _tmp17_);
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			_tmp14_ = TRUE;
		} else {
			_tmp14_ = (state & GDK_CONTROL_MASK) > 0;
		}
		want_earmark = _tmp14_;
		if (want_earmark) {
			SudokuGame* _tmp19_;
			GameMode _tmp20_;
			_tmp19_ = self->priv->game;
			_tmp20_ = _tmp19_->mode;
			_tmp18_ = _tmp20_ == GAME_MODE_PLAY;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			gboolean new_state = FALSE;
			SudokuGame* _tmp21_;
			SudokuBoard* _tmp22_;
			NumberPicker* _tmp23_;
			NumberPicker* _tmp24_;
			_tmp21_ = self->priv->game;
			_tmp22_ = _tmp21_->board;
			new_state = !sudoku_board_is_earmark_enabled (_tmp22_, self->priv->row, self->priv->col, k_no);
			_tmp23_ = self->priv->earmark_picker;
			if (_tmp23_ == NULL) {
				sudoku_cell_view_create_earmark_picker (self);
			}
			_tmp24_ = self->priv->earmark_picker;
			if (number_picker_set_earmark (_tmp24_, self->priv->row, self->priv->col, k_no - 1, new_state)) {
				gtk_widget_queue_draw ((GtkWidget*) self);
			}
		} else {
			SudokuGame* _tmp25_;
			SudokuBoard* _tmp26_;
			sudoku_cell_view_set_value (self, k_no);
			_tmp25_ = self->priv->game;
			_tmp26_ = _tmp25_->board;
			sudoku_board_disable_all_earmarks (_tmp26_, self->priv->row, self->priv->col);
			sudoku_cell_view_hide_both_popovers (self);
		}
		result = TRUE;
		_g_free0 (k_name);
		return result;
	}
	if (k_no == 0) {
		_tmp28_ = TRUE;
	} else {
		const gchar* _tmp29_;
		_tmp29_ = k_name;
		_tmp28_ = g_strcmp0 (_tmp29_, "BackSpace") == 0;
	}
	if (_tmp28_) {
		_tmp27_ = TRUE;
	} else {
		const gchar* _tmp30_;
		_tmp30_ = k_name;
		_tmp27_ = g_strcmp0 (_tmp30_, "Delete") == 0;
	}
	if (_tmp27_) {
		sudoku_cell_view_set_value (self, 0);
		g_object_notify ((GObject*) self, "value");
		result = TRUE;
		_g_free0 (k_name);
		return result;
	}
	_tmp33_ = k_name;
	if (g_strcmp0 (_tmp33_, "space") == 0) {
		_tmp32_ = TRUE;
	} else {
		const gchar* _tmp34_;
		_tmp34_ = k_name;
		_tmp32_ = g_strcmp0 (_tmp34_, "Return") == 0;
	}
	if (_tmp32_) {
		_tmp31_ = TRUE;
	} else {
		const gchar* _tmp35_;
		_tmp35_ = k_name;
		_tmp31_ = g_strcmp0 (_tmp35_, "KP_Enter") == 0;
	}
	if (_tmp31_) {
		GtkPopover* _tmp36_;
		_tmp36_ = self->priv->popover;
		if (_tmp36_ != NULL) {
			GtkPopover* _tmp37_;
			_tmp37_ = self->priv->popover;
			gtk_widget_hide ((GtkWidget*) _tmp37_);
			result = FALSE;
			_g_free0 (k_name);
			return result;
		}
		sudoku_cell_view_show_number_picker (self);
		result = TRUE;
		_g_free0 (k_name);
		return result;
	}
	_tmp38_ = k_name;
	if (g_strcmp0 (_tmp38_, "Escape") == 0) {
		sudoku_cell_view_hide_both_popovers (self);
		result = TRUE;
		_g_free0 (k_name);
		return result;
	}
	result = FALSE;
	_g_free0 (k_name);
	return result;
}

static gboolean
sudoku_cell_view_real_draw (GtkWidget* base,
                            cairo_t* c)
{
	SudokuCellView * self;
	gint glyph_width = 0;
	gint glyph_height = 0;
	PangoLayout* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp57_ = FALSE;
	gboolean result = FALSE;
	self = (SudokuCellView*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_ = self->priv->layout;
	pango_layout_get_pixel_size (_tmp0_, &_tmp1_, &_tmp2_);
	glyph_width = _tmp1_;
	glyph_height = _tmp2_;
	if (self->priv->_show_warnings) {
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
		GeeSet* _tmp6_;
		Coord _tmp7_ = {0};
		_tmp4_ = self->priv->game;
		_tmp5_ = _tmp4_->board;
		_tmp6_ = _tmp5_->broken_coords;
		coord_init (&_tmp7_, self->priv->row, self->priv->col);
		_tmp3_ = gee_collection_contains ((GeeCollection*) _tmp6_, &_tmp7_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
	} else {
		if (self->priv->_selected) {
			cairo_set_source_rgb (c, 0.2, 0.2, 0.2);
		} else {
			cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
		}
	}
	_tmp8_ = self->priv->game;
	_tmp9_ = sudoku_game_get_paused (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		result = FALSE;
		return result;
	}
	_tmp11_ = sudoku_cell_view_get_value (self);
	_tmp12_ = _tmp11_;
	if (_tmp12_ != 0) {
		gint width = 0;
		gint height = 0;
		PangoLayout* _tmp13_;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gdouble scale = 0.0;
		PangoLayout* _tmp16_;
		_tmp13_ = self->priv->layout;
		pango_layout_get_size (_tmp13_, &_tmp14_, &_tmp15_);
		width = _tmp14_;
		height = _tmp15_;
		height /= PANGO_SCALE;
		scale = (((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self)) / self->priv->size_ratio) / height;
		cairo_move_to (c, (gtk_widget_get_allocated_width ((GtkWidget*) self) - (glyph_width * scale)) / 2, (gtk_widget_get_allocated_height ((GtkWidget*) self) - (glyph_height * scale)) / 2);
		cairo_save (c);
		cairo_scale (c, scale, scale);
		_tmp16_ = self->priv->layout;
		pango_cairo_show_layout (c, _tmp16_);
		cairo_restore (c);
	}
	_tmp18_ = sudoku_cell_view_get_is_fixed (self);
	_tmp19_ = _tmp18_;
	if (_tmp19_) {
		SudokuGame* _tmp20_;
		GameMode _tmp21_;
		_tmp20_ = self->priv->game;
		_tmp21_ = _tmp20_->mode;
		_tmp17_ = _tmp21_ == GAME_MODE_PLAY;
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		result = FALSE;
		return result;
	}
	if (!self->priv->_show_possibilities) {
		gdouble earmark_size = 0.0;
		SudokuGame* _tmp22_;
		SudokuBoard* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		earmark_size = gtk_widget_get_allocated_height ((GtkWidget*) self) / (self->priv->size_ratio * 2);
		cairo_set_font_size (c, earmark_size);
		cairo_move_to (c, (gdouble) 0, earmark_size);
		cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
		_tmp22_ = self->priv->game;
		_tmp23_ = _tmp22_->board;
		_tmp24_ = sudoku_board_get_earmarks_string (_tmp23_, self->priv->row, self->priv->col);
		_tmp25_ = _tmp24_;
		cairo_show_text (c, _tmp25_);
		_g_free0 (_tmp25_);
	} else {
		gint _tmp26_;
		gint _tmp27_;
		_tmp26_ = sudoku_cell_view_get_value (self);
		_tmp27_ = _tmp26_;
		if (_tmp27_ == 0) {
			gdouble possibility_size = 0.0;
			gboolean* possibilities = NULL;
			SudokuGame* _tmp28_;
			SudokuBoard* _tmp29_;
			gint _tmp30_ = 0;
			gboolean* _tmp31_;
			gint possibilities_length1;
			gint _possibilities_size_;
			gint height = 0;
			SudokuGame* _tmp32_;
			SudokuBoard* _tmp33_;
			gint _tmp34_;
			gint _tmp35_;
			gint width = 0;
			SudokuGame* _tmp36_;
			SudokuBoard* _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
			gint num = 0;
			possibility_size = gtk_widget_get_allocated_height ((GtkWidget*) self) / (self->priv->size_ratio * 2);
			cairo_set_font_size (c, possibility_size);
			cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
			_tmp28_ = self->priv->game;
			_tmp29_ = _tmp28_->board;
			_tmp31_ = sudoku_board_get_possibilities_as_bool_array (_tmp29_, self->priv->row, self->priv->col, &_tmp30_);
			possibilities = _tmp31_;
			possibilities_length1 = _tmp30_;
			_possibilities_size_ = possibilities_length1;
			_tmp32_ = self->priv->game;
			_tmp33_ = _tmp32_->board;
			_tmp34_ = sudoku_board_get_block_cols (_tmp33_);
			_tmp35_ = _tmp34_;
			height = gtk_widget_get_allocated_height ((GtkWidget*) self) / _tmp35_;
			_tmp36_ = self->priv->game;
			_tmp37_ = _tmp36_->board;
			_tmp38_ = sudoku_board_get_block_rows (_tmp37_);
			_tmp39_ = _tmp38_;
			width = gtk_widget_get_allocated_height ((GtkWidget*) self) / _tmp39_;
			num = 0;
			{
				gint row_tmp = 0;
				row_tmp = 0;
				{
					gboolean _tmp40_ = FALSE;
					_tmp40_ = TRUE;
					while (TRUE) {
						SudokuGame* _tmp42_;
						SudokuBoard* _tmp43_;
						gint _tmp44_;
						gint _tmp45_;
						if (!_tmp40_) {
							gint _tmp41_;
							_tmp41_ = row_tmp;
							row_tmp = _tmp41_ + 1;
						}
						_tmp40_ = FALSE;
						_tmp42_ = self->priv->game;
						_tmp43_ = _tmp42_->board;
						_tmp44_ = sudoku_board_get_block_rows (_tmp43_);
						_tmp45_ = _tmp44_;
						if (!(row_tmp < _tmp45_)) {
							break;
						}
						{
							gint col_tmp = 0;
							col_tmp = 0;
							{
								gboolean _tmp46_ = FALSE;
								_tmp46_ = TRUE;
								while (TRUE) {
									SudokuGame* _tmp48_;
									SudokuBoard* _tmp49_;
									gint _tmp50_;
									gint _tmp51_;
									gint _tmp52_;
									gboolean* _tmp53_;
									gint _tmp53__length1;
									gboolean _tmp54_;
									if (!_tmp46_) {
										gint _tmp47_;
										_tmp47_ = col_tmp;
										col_tmp = _tmp47_ + 1;
									}
									_tmp46_ = FALSE;
									_tmp48_ = self->priv->game;
									_tmp49_ = _tmp48_->board;
									_tmp50_ = sudoku_board_get_block_cols (_tmp49_);
									_tmp51_ = _tmp50_;
									if (!(col_tmp < _tmp51_)) {
										break;
									}
									_tmp52_ = num;
									num = _tmp52_ + 1;
									_tmp53_ = possibilities;
									_tmp53__length1 = possibilities_length1;
									_tmp54_ = _tmp53_[num - 1];
									if (_tmp54_) {
										gchar* _tmp55_;
										gchar* _tmp56_;
										cairo_move_to (c, (gdouble) (col_tmp * width), (row_tmp * height) + possibility_size);
										_tmp55_ = g_strdup_printf ("%d", num);
										_tmp56_ = _tmp55_;
										cairo_show_text (c, _tmp56_);
										_g_free0 (_tmp56_);
									}
								}
							}
						}
					}
				}
			}
			possibilities = (g_free (possibilities), NULL);
		}
	}
	if (self->priv->_show_warnings) {
		gboolean _tmp58_ = FALSE;
		gint _tmp59_;
		gint _tmp60_;
		_tmp59_ = sudoku_cell_view_get_value (self);
		_tmp60_ = _tmp59_;
		if (_tmp60_ == 0) {
			SudokuGame* _tmp61_;
			SudokuBoard* _tmp62_;
			_tmp61_ = self->priv->game;
			_tmp62_ = _tmp61_->board;
			_tmp58_ = sudoku_board_count_possibilities (_tmp62_, self->priv->row, self->priv->col) == 0;
		} else {
			_tmp58_ = FALSE;
		}
		_tmp57_ = _tmp58_;
	} else {
		_tmp57_ = FALSE;
	}
	if (_tmp57_) {
		gchar* warning = NULL;
		gchar* _tmp63_;
		cairo_text_extents_t extents = {0};
		const gchar* _tmp64_;
		cairo_text_extents_t _tmp65_ = {0};
		cairo_text_extents_t _tmp66_;
		cairo_text_extents_t _tmp67_;
		const gchar* _tmp68_;
		_tmp63_ = g_strdup ("X");
		warning = _tmp63_;
		cairo_set_font_size (c, (gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) / 2));
		_tmp64_ = warning;
		cairo_text_extents (c, _tmp64_, &_tmp65_);
		extents = _tmp65_;
		_tmp66_ = extents;
		_tmp67_ = extents;
		cairo_move_to (c, ((gtk_widget_get_allocated_width ((GtkWidget*) self) - _tmp66_.width) / 2) - 1, ((gtk_widget_get_allocated_height ((GtkWidget*) self) + _tmp67_.height) / 2) + 1);
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
		_tmp68_ = warning;
		cairo_show_text (c, _tmp68_);
		_g_free0 (warning);
	}
	result = FALSE;
	return result;
}

void
sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (row == self->priv->row) {
		_tmp0_ = col == self->priv->col;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		SudokuGame* _tmp1_;
		GameMode _tmp2_;
		sudoku_cell_view_set_value (self, new_val);
		_tmp1_ = self->priv->game;
		_tmp2_ = _tmp1_->mode;
		if (_tmp2_ == GAME_MODE_CREATE) {
			if (self->priv->_selected) {
				sudoku_cell_view_set_background_color (self, &selected_bg_color);
			} else {
				GdkRGBA _tmp3_ = {0};
				gboolean _tmp4_;
				gboolean _tmp5_;
				_tmp4_ = sudoku_cell_view_get_is_fixed (self);
				_tmp5_ = _tmp4_;
				if (_tmp5_) {
					_tmp3_ = fixed_cell_color;
				} else {
					_tmp3_ = free_cell_color;
				}
				sudoku_cell_view_set_background_color (self, &_tmp3_);
			}
		}
		g_object_notify ((GObject*) self, "value");
	}
}

void
sudoku_cell_view_clear (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = _tmp0_->board;
	sudoku_board_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
}

gint
sudoku_cell_view_get_value (SudokuCellView* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->game;
	_tmp1_ = _tmp0_->board;
	result = sudoku_board_get (_tmp1_, self->priv->row, self->priv->col);
	return result;
}

void
sudoku_cell_view_set_value (SudokuCellView* self,
                            gint value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuGame* _tmp25_;
	SudokuBoard* _tmp26_;
	PangoLayout* _tmp34_;
	SudokuGame* _tmp35_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_cell_view_get_is_fixed (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gchar* text = NULL;
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		PangoLayout* _tmp6_;
		PangoLayout* _tmp7_;
		GtkStyle* _tmp8_;
		GtkStyle* _tmp9_;
		PangoFontDescription* _tmp10_;
		SudokuGame* _tmp11_;
		GameMode _tmp12_;
		_tmp2_ = self->priv->game;
		_tmp3_ = _tmp2_->board;
		_tmp4_ = g_strdup_printf ("%d", sudoku_board_get (_tmp3_, self->priv->row, self->priv->col));
		text = _tmp4_;
		_tmp5_ = text;
		_tmp6_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp5_);
		_g_object_unref0 (self->priv->layout);
		self->priv->layout = _tmp6_;
		_tmp7_ = self->priv->layout;
		_tmp8_ = gtk_widget_get_style ((GtkWidget*) self);
		_tmp9_ = _tmp8_;
		_tmp10_ = _tmp9_->font_desc;
		pango_layout_set_font_description (_tmp7_, _tmp10_);
		_tmp11_ = self->priv->game;
		_tmp12_ = _tmp11_->mode;
		if (_tmp12_ == GAME_MODE_PLAY) {
			_g_free0 (text);
			return;
		}
		_g_free0 (text);
	}
	if (value == 0) {
		gchar* text = NULL;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		PangoLayout* _tmp15_;
		PangoLayout* _tmp16_;
		GtkStyle* _tmp17_;
		GtkStyle* _tmp18_;
		PangoFontDescription* _tmp19_;
		SudokuGame* _tmp20_;
		SudokuBoard* _tmp21_;
		SudokuGame* _tmp23_;
		GameMode _tmp24_;
		_tmp13_ = g_strdup ("");
		text = _tmp13_;
		_tmp14_ = text;
		_tmp15_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp14_);
		_g_object_unref0 (self->priv->layout);
		self->priv->layout = _tmp15_;
		_tmp16_ = self->priv->layout;
		_tmp17_ = gtk_widget_get_style ((GtkWidget*) self);
		_tmp18_ = _tmp17_;
		_tmp19_ = _tmp18_->font_desc;
		pango_layout_set_font_description (_tmp16_, _tmp19_);
		_tmp20_ = self->priv->game;
		_tmp21_ = _tmp20_->board;
		if (sudoku_board_get (_tmp21_, self->priv->row, self->priv->col) != 0) {
			SudokuGame* _tmp22_;
			_tmp22_ = self->priv->game;
			sudoku_game_remove (_tmp22_, self->priv->row, self->priv->col);
		}
		_tmp23_ = self->priv->game;
		_tmp24_ = _tmp23_->mode;
		if (_tmp24_ == GAME_MODE_PLAY) {
			_g_free0 (text);
			return;
		}
		_g_free0 (text);
	}
	_tmp25_ = self->priv->game;
	_tmp26_ = _tmp25_->board;
	if (value == sudoku_board_get (_tmp26_, self->priv->row, self->priv->col)) {
		gchar* text = NULL;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		PangoLayout* _tmp29_;
		PangoLayout* _tmp30_;
		GtkStyle* _tmp31_;
		GtkStyle* _tmp32_;
		PangoFontDescription* _tmp33_;
		_tmp27_ = g_strdup_printf ("%d", value);
		text = _tmp27_;
		_tmp28_ = text;
		_tmp29_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp28_);
		_g_object_unref0 (self->priv->layout);
		self->priv->layout = _tmp29_;
		_tmp30_ = self->priv->layout;
		_tmp31_ = gtk_widget_get_style ((GtkWidget*) self);
		_tmp32_ = _tmp31_;
		_tmp33_ = _tmp32_->font_desc;
		pango_layout_set_font_description (_tmp30_, _tmp33_);
		_g_free0 (text);
		return;
	}
	_tmp34_ = self->priv->layout;
	_vala_assert (_tmp34_ != NULL, "layout != null");
	_tmp35_ = self->priv->game;
	sudoku_game_insert (_tmp35_, self->priv->row, self->priv->col, value);
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY]);
}

gboolean
sudoku_cell_view_get_is_fixed (SudokuCellView* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->game;
	_tmp1_ = _tmp0_->board;
	_tmp2_ = _tmp1_->is_fixed;
	_tmp2__length1 = _tmp1_->is_fixed_length1;
	_tmp2__length2 = _tmp1_->is_fixed_length2;
	_tmp3_ = _tmp2_[(self->priv->row * _tmp2__length2) + self->priv->col];
	result = _tmp3_;
	return result;
}

gboolean
sudoku_cell_view_get_show_possibilities (SudokuCellView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_possibilities;
	return result;
}

void
sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                         gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_possibilities = value;
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
}

gboolean
sudoku_cell_view_get_show_warnings (SudokuCellView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_warnings;
	return result;
}

void
sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_warnings = value;
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY]);
}

gboolean
sudoku_cell_view_get_selected (SudokuCellView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_selected;
	return result;
}

void
sudoku_cell_view_set_selected (SudokuCellView* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	if (sudoku_cell_view_get_selected (self) != value) {
		self->priv->_selected = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY]);
	}
}

void
sudoku_cell_view_get_background_color (SudokuCellView* self,
                                       GdkRGBA * result)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_background_color;
	*result = _tmp0_;
	return;
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->red != s2->red) {
		return FALSE;
	}
	if (s1->green != s2->green) {
		return FALSE;
	}
	if (s1->blue != s2->blue) {
		return FALSE;
	}
	if (s1->alpha != s2->alpha) {
		return FALSE;
	}
	return TRUE;
}

void
sudoku_cell_view_set_background_color (SudokuCellView* self,
                                       GdkRGBA * value)
{
	GdkRGBA old_value;
	g_return_if_fail (self != NULL);
	sudoku_cell_view_get_background_color (self, &old_value);
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
		GdkRGBA _tmp0_;
		_tmp0_ = *value;
		self->priv->_background_color = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY]);
	}
}

static void
sudoku_cell_view_class_init (SudokuCellViewClass * klass,
                             gpointer klass_data)
{
	sudoku_cell_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuCellView_private_offset);
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) sudoku_cell_view_real_button_press_event;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) sudoku_cell_view_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_VALUE_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SELECTED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY] = g_param_spec_boxed ("background-color", "background-color", "background-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
sudoku_cell_view_instance_init (SudokuCellView * self,
                                gpointer klass)
{
	self->priv = sudoku_cell_view_get_instance_private (self);
	self->priv->size_ratio = (gdouble) 2;
	self->priv->_show_warnings = TRUE;
}

static void
sudoku_cell_view_finalize (GObject * obj)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
	_g_object_unref0 (self->priv->layout);
	_g_object_unref0 (self->priv->popover);
	_g_object_unref0 (self->priv->earmark_popover);
	_g_object_unref0 (self->priv->game);
	_g_object_unref0 (self->priv->number_picker);
	_g_object_unref0 (self->priv->earmark_picker);
	_g_object_unref0 (self->priv->key_controller);
	G_OBJECT_CLASS (sudoku_cell_view_parent_class)->finalize (obj);
}

static GType
sudoku_cell_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCellView), 0, (GInstanceInitFunc) sudoku_cell_view_instance_init, NULL };
	GType sudoku_cell_view_type_id;
	sudoku_cell_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "SudokuCellView", &g_define_type_info, 0);
	SudokuCellView_private_offset = g_type_add_instance_private (sudoku_cell_view_type_id, sizeof (SudokuCellViewPrivate));
	return sudoku_cell_view_type_id;
}

GType
sudoku_cell_view_get_type (void)
{
	static volatile gsize sudoku_cell_view_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_cell_view_type_id__volatile)) {
		GType sudoku_cell_view_type_id;
		sudoku_cell_view_type_id = sudoku_cell_view_get_type_once ();
		g_once_init_leave (&sudoku_cell_view_type_id__volatile, sudoku_cell_view_type_id);
	}
	return sudoku_cell_view_type_id__volatile;
}

static void
_vala_sudoku_cell_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
	switch (property_id) {
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
		g_value_set_int (value, sudoku_cell_view_get_value (self));
		break;
		case SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_view_get_is_fixed (self));
		break;
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_view_get_show_possibilities (self));
		break;
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_view_get_show_warnings (self));
		break;
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_view_get_selected (self));
		break;
		case SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY:
		{
			GdkRGBA boxed;
			sudoku_cell_view_get_background_color (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_cell_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
	switch (property_id) {
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
		sudoku_cell_view_set_value (self, g_value_get_int (value));
		break;
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		sudoku_cell_view_set_show_possibilities (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
		sudoku_cell_view_set_show_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
		sudoku_cell_view_set_selected (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY:
		sudoku_cell_view_set_background_color (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	SudokuCellView** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCellView* _tmp1_;
	SudokuCellView** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCellView* _tmp3_;
	SudokuCellView** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	SudokuCellView* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cells;
	_tmp0__length1 = self->priv->cells_length1;
	_tmp0__length2 = self->priv->cells_length2;
	_tmp1_ = _tmp0_[(self->priv->selected_row * _tmp0__length2) + self->priv->selected_col];
	sudoku_cell_view_set_selected (_tmp1_, FALSE);
	_tmp2_ = self->priv->cells;
	_tmp2__length1 = self->priv->cells_length1;
	_tmp2__length2 = self->priv->cells_length2;
	_tmp3_ = _tmp2_[(self->priv->selected_row * _tmp2__length2) + self->priv->selected_col];
	gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
	self->priv->selected_row = cell_row;
	self->priv->selected_col = cell_col;
	_tmp4_ = self->priv->cells;
	_tmp4__length1 = self->priv->cells_length1;
	_tmp4__length2 = self->priv->cells_length2;
	_tmp5_ = _tmp4_[(self->priv->selected_row * _tmp4__length2) + self->priv->selected_col];
	sudoku_cell_view_set_selected (_tmp5_, TRUE);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		SudokuView* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->game);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static gboolean
_sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                         cairo_t* cr,
                                         gpointer self)
{
	gboolean result;
	result = sudoku_view_draw_board ((SudokuView*) self, cr);
	return result;
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		SudokuView* self;
		self = _data8_->_data7_->self;
		block7_data_unref (_data8_->_data7_);
		_data8_->_data7_ = NULL;
		g_slice_free (Block8Data, _data8_);
	}
}

static gboolean
________lambda13_ (Block8Data* _data8_)
{
	Block7Data* _data7_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCellView** _tmp70_;
	gint _tmp70__length1;
	gint _tmp70__length2;
	SudokuCellView* _tmp71_;
	gboolean result = FALSE;
	_data7_ = _data8_->_data7_;
	self = _data7_->self;
	_tmp0_ = sudoku_game_get_paused (_data7_->game);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	sudoku_view_set_selected (self, _data8_->cell_row, _data8_->cell_col);
	{
		gint col_tmp = 0;
		col_tmp = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				GdkRGBA _tmp7_ = {0};
				gboolean _tmp8_ = FALSE;
				GdkRGBA color = {0};
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = col_tmp;
					col_tmp = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = _data7_->game->board;
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
				_tmp6_ = _tmp5_;
				if (!(col_tmp < _tmp6_)) {
					break;
				}
				if (col_tmp == _data8_->cell_col) {
					_tmp8_ = self->priv->_highlighter;
				} else {
					_tmp8_ = FALSE;
				}
				if (_tmp8_) {
					_tmp7_ = highlight_color;
				} else {
					_tmp7_ = free_cell_color;
				}
				color = _tmp7_;
				{
					gint row_tmp = 0;
					row_tmp = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							GdkRGBA _tmp14_ = {0};
							SudokuCellView** _tmp15_;
							gint _tmp15__length1;
							gint _tmp15__length2;
							SudokuCellView* _tmp16_;
							gboolean _tmp17_;
							gboolean _tmp18_;
							SudokuCellView** _tmp20_;
							gint _tmp20__length1;
							gint _tmp20__length2;
							SudokuCellView* _tmp21_;
							if (!_tmp9_) {
								gint _tmp10_;
								_tmp10_ = row_tmp;
								row_tmp = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							_tmp11_ = _data7_->game->board;
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
							_tmp13_ = _tmp12_;
							if (!(row_tmp < _tmp13_)) {
								break;
							}
							_tmp15_ = self->priv->cells;
							_tmp15__length1 = self->priv->cells_length1;
							_tmp15__length2 = self->priv->cells_length2;
							_tmp16_ = _tmp15_[(row_tmp * _tmp15__length2) + col_tmp];
							_tmp17_ = sudoku_cell_view_get_is_fixed (_tmp16_);
							_tmp18_ = _tmp17_;
							if (_tmp18_) {
								_tmp14_ = fixed_cell_color;
							} else {
								GdkRGBA _tmp19_;
								_tmp19_ = color;
								_tmp14_ = _tmp19_;
							}
							_tmp20_ = self->priv->cells;
							_tmp20__length1 = self->priv->cells_length1;
							_tmp20__length2 = self->priv->cells_length2;
							_tmp21_ = _tmp20_[(row_tmp * _tmp20__length2) + col_tmp];
							sudoku_cell_view_set_background_color (_tmp21_, &_tmp14_);
						}
					}
				}
			}
		}
	}
	{
		gint col_tmp = 0;
		col_tmp = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				SudokuCellView** _tmp27_;
				gint _tmp27__length1;
				gint _tmp27__length2;
				SudokuCellView* _tmp28_;
				gboolean _tmp29_;
				gboolean _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = col_tmp;
					col_tmp = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp24_ = _data7_->game->board;
				_tmp25_ = sudoku_board_get_cols (_tmp24_);
				_tmp26_ = _tmp25_;
				if (!(col_tmp < _tmp26_)) {
					break;
				}
				_tmp27_ = self->priv->cells;
				_tmp27__length1 = self->priv->cells_length1;
				_tmp27__length2 = self->priv->cells_length2;
				_tmp28_ = _tmp27_[(_data8_->cell_row * _tmp27__length2) + col_tmp];
				_tmp29_ = sudoku_cell_view_get_is_fixed (_tmp28_);
				_tmp30_ = _tmp29_;
				if (_tmp30_) {
					SudokuCellView** _tmp31_;
					gint _tmp31__length1;
					gint _tmp31__length2;
					SudokuCellView* _tmp32_;
					_tmp31_ = self->priv->cells;
					_tmp31__length1 = self->priv->cells_length1;
					_tmp31__length2 = self->priv->cells_length2;
					_tmp32_ = _tmp31_[(_data8_->cell_row * _tmp31__length2) + col_tmp];
					sudoku_cell_view_set_background_color (_tmp32_, &fixed_cell_color);
				} else {
					if (self->priv->_highlighter) {
						SudokuCellView** _tmp33_;
						gint _tmp33__length1;
						gint _tmp33__length2;
						SudokuCellView* _tmp34_;
						_tmp33_ = self->priv->cells;
						_tmp33__length1 = self->priv->cells_length1;
						_tmp33__length2 = self->priv->cells_length2;
						_tmp34_ = _tmp33_[(_data8_->cell_row * _tmp33__length2) + col_tmp];
						sudoku_cell_view_set_background_color (_tmp34_, &highlight_color);
					} else {
						SudokuCellView** _tmp35_;
						gint _tmp35__length1;
						gint _tmp35__length2;
						SudokuCellView* _tmp36_;
						_tmp35_ = self->priv->cells;
						_tmp35__length1 = self->priv->cells_length1;
						_tmp35__length2 = self->priv->cells_length2;
						_tmp36_ = _tmp35_[(_data8_->cell_row * _tmp35__length2) + col_tmp];
						sudoku_cell_view_set_background_color (_tmp36_, &free_cell_color);
					}
				}
			}
		}
	}
	{
		GeeList* _coord_list = NULL;
		SudokuBoard* _tmp37_;
		GeeMap* _tmp38_;
		SudokuBoard* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		SudokuBoard* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		Coord _tmp45_ = {0};
		gpointer _tmp46_;
		gint _coord_size = 0;
		GeeList* _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		gint _coord_index = 0;
		_tmp37_ = _data7_->game->board;
		_tmp38_ = _tmp37_->coords_for_block;
		_tmp39_ = _data7_->game->board;
		_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
		_tmp41_ = _tmp40_;
		_tmp42_ = _data7_->game->board;
		_tmp43_ = sudoku_board_get_block_cols (_tmp42_);
		_tmp44_ = _tmp43_;
		coord_init (&_tmp45_, _data8_->cell_row / _tmp41_, _data8_->cell_col / _tmp44_);
		_tmp46_ = gee_map_get (_tmp38_, &_tmp45_);
		_coord_list = (GeeList*) _tmp46_;
		_tmp47_ = _coord_list;
		_tmp48_ = gee_collection_get_size ((GeeCollection*) _tmp47_);
		_tmp49_ = _tmp48_;
		_coord_size = _tmp49_;
		_coord_index = -1;
		while (TRUE) {
			Coord* coord = NULL;
			GeeList* _tmp50_;
			gpointer _tmp51_;
			SudokuCellView** _tmp52_;
			gint _tmp52__length1;
			gint _tmp52__length2;
			Coord* _tmp53_;
			Coord* _tmp54_;
			SudokuCellView* _tmp55_;
			gboolean _tmp56_;
			gboolean _tmp57_;
			_coord_index = _coord_index + 1;
			if (!(_coord_index < _coord_size)) {
				break;
			}
			_tmp50_ = _coord_list;
			_tmp51_ = gee_list_get (_tmp50_, _coord_index);
			coord = (Coord*) _tmp51_;
			_tmp52_ = self->priv->cells;
			_tmp52__length1 = self->priv->cells_length1;
			_tmp52__length2 = self->priv->cells_length2;
			_tmp53_ = coord;
			_tmp54_ = coord;
			_tmp55_ = _tmp52_[((*_tmp53_).row * _tmp52__length2) + (*_tmp54_).col];
			_tmp56_ = sudoku_cell_view_get_is_fixed (_tmp55_);
			_tmp57_ = _tmp56_;
			if (_tmp57_) {
				SudokuCellView** _tmp58_;
				gint _tmp58__length1;
				gint _tmp58__length2;
				Coord* _tmp59_;
				Coord* _tmp60_;
				SudokuCellView* _tmp61_;
				_tmp58_ = self->priv->cells;
				_tmp58__length1 = self->priv->cells_length1;
				_tmp58__length2 = self->priv->cells_length2;
				_tmp59_ = coord;
				_tmp60_ = coord;
				_tmp61_ = _tmp58_[((*_tmp59_).row * _tmp58__length2) + (*_tmp60_).col];
				sudoku_cell_view_set_background_color (_tmp61_, &fixed_cell_color);
			} else {
				if (self->priv->_highlighter) {
					SudokuCellView** _tmp62_;
					gint _tmp62__length1;
					gint _tmp62__length2;
					Coord* _tmp63_;
					Coord* _tmp64_;
					SudokuCellView* _tmp65_;
					_tmp62_ = self->priv->cells;
					_tmp62__length1 = self->priv->cells_length1;
					_tmp62__length2 = self->priv->cells_length2;
					_tmp63_ = coord;
					_tmp64_ = coord;
					_tmp65_ = _tmp62_[((*_tmp63_).row * _tmp62__length2) + (*_tmp64_).col];
					sudoku_cell_view_set_background_color (_tmp65_, &highlight_color);
				} else {
					SudokuCellView** _tmp66_;
					gint _tmp66__length1;
					gint _tmp66__length2;
					Coord* _tmp67_;
					Coord* _tmp68_;
					SudokuCellView* _tmp69_;
					_tmp66_ = self->priv->cells;
					_tmp66__length1 = self->priv->cells_length1;
					_tmp66__length2 = self->priv->cells_length2;
					_tmp67_ = coord;
					_tmp68_ = coord;
					_tmp69_ = _tmp66_[((*_tmp67_).row * _tmp66__length2) + (*_tmp68_).col];
					sudoku_cell_view_set_background_color (_tmp69_, &free_cell_color);
				}
			}
			_g_free0 (coord);
		}
		_g_object_unref0 (_coord_list);
	}
	_tmp70_ = self->priv->cells;
	_tmp70__length1 = self->priv->cells_length1;
	_tmp70__length2 = self->priv->cells_length2;
	_tmp71_ = _tmp70_[(_data8_->cell_row * _tmp70__length2) + _data8_->cell_col];
	sudoku_cell_view_set_background_color (_tmp71_, &selected_bg_color);
	gtk_widget_queue_draw ((GtkWidget*) self);
	result = FALSE;
	return result;
}

static gboolean
_________lambda13__gtk_widget_focus_in_event (GtkWidget* _sender,
                                              GdkEventFocus* event,
                                              gpointer self)
{
	gboolean result;
	result = ________lambda13_ (self);
	return result;
}

static void
________lambda14_ (Block8Data* _data8_,
                   GObject* s,
                   GParamSpec* p)
{
	Block7Data* _data7_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	_data7_ = _data8_->_data7_;
	self = _data7_->self;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	if (self->priv->_show_possibilities) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = self->priv->_show_warnings;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		SudokuBoard* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = _data7_->game->board;
		_tmp4_ = sudoku_board_get_broken (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->previous_board_broken_state;
	}
	if (_tmp0_) {
		SudokuBoard* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = _data7_->game->board;
		_tmp7_ = sudoku_board_get_broken (_tmp6_);
		_tmp8_ = _tmp7_;
		self->priv->previous_board_broken_state = _tmp8_;
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
_________lambda14__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
	________lambda14_ (self, _sender, pspec);
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block7Data* _data7_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	GtkOverlay* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkDrawingArea* _tmp4_;
	GtkGrid* _tmp5_;
	SudokuGame* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	SudokuBoard* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	SudokuBoard* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	SudokuCellView** _tmp20_;
	GtkOverlay* _tmp44_;
	GtkDrawingArea* _tmp45_;
	GtkOverlay* _tmp46_;
	GtkGrid* _tmp47_;
	GtkDrawingArea* _tmp48_;
	GtkGrid* _tmp49_;
	GtkOverlay* _tmp50_;
	g_return_val_if_fail (game != NULL, NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (game);
	_g_object_unref0 (_data7_->game);
	_data7_->game = _tmp0_;
	self = (SudokuView*) g_object_new (object_type, NULL);
	_data7_->self = g_object_ref (self);
	gtk_frame_set_shadow_type ((GtkFrame*) self, GTK_SHADOW_NONE);
	g_object_set ((GtkAspectFrame*) self, "obey-child", FALSE, NULL);
	g_object_set ((GtkAspectFrame*) self, "ratio", (gfloat) 1, NULL);
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->overlay);
	self->priv->overlay = _tmp1_;
	_tmp2_ = self->priv->overlay;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
	_tmp3_ = (GtkDrawingArea*) gtk_drawing_area_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->drawing);
	self->priv->drawing = _tmp3_;
	_tmp4_ = self->priv->drawing;
	g_signal_connect_object ((GtkWidget*) _tmp4_, "draw", (GCallback) _sudoku_view_draw_board_gtk_widget_draw, self, 0);
	_tmp5_ = self->priv->grid;
	if (_tmp5_ != NULL) {
		GtkOverlay* _tmp6_;
		GtkGrid* _tmp7_;
		_tmp6_ = self->priv->overlay;
		_tmp7_ = self->priv->grid;
		gtk_container_remove ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
	}
	_tmp8_ = _g_object_ref0 (_data7_->game);
	_g_object_unref0 (self->game);
	self->game = _tmp8_;
	_tmp9_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp9_;
	_tmp10_ = self->priv->grid;
	gtk_grid_set_row_spacing (_tmp10_, 1);
	_tmp11_ = self->priv->grid;
	gtk_grid_set_column_spacing (_tmp11_, 1);
	_tmp12_ = self->priv->grid;
	gtk_grid_set_column_homogeneous (_tmp12_, TRUE);
	_tmp13_ = self->priv->grid;
	gtk_grid_set_row_homogeneous (_tmp13_, TRUE);
	_tmp14_ = _data7_->game->board;
	_tmp15_ = sudoku_board_get_rows (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = _data7_->game->board;
	_tmp18_ = sudoku_board_get_cols (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_new0 (SudokuCellView*, (_tmp16_ * _tmp19_) + 1);
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->cells = _tmp20_;
	self->priv->cells_length1 = _tmp16_;
	self->priv->cells_length2 = _tmp19_;
	{
		gint row = 0;
		row = 0;
		{
			gboolean _tmp21_ = FALSE;
			_tmp21_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				if (!_tmp21_) {
					gint _tmp22_;
					_tmp22_ = row;
					row = _tmp22_ + 1;
				}
				_tmp21_ = FALSE;
				_tmp23_ = _data7_->game->board;
				_tmp24_ = sudoku_board_get_rows (_tmp23_);
				_tmp25_ = _tmp24_;
				if (!(row < _tmp25_)) {
					break;
				}
				{
					gint col = 0;
					col = 0;
					{
						gboolean _tmp26_ = FALSE;
						_tmp26_ = TRUE;
						while (TRUE) {
							Block8Data* _data8_;
							SudokuBoard* _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							SudokuCellView* cell = NULL;
							SudokuCellView* _tmp31_;
							GdkRGBA _tmp32_ = {0};
							SudokuCellView* _tmp33_;
							gboolean _tmp34_;
							gboolean _tmp35_;
							SudokuCellView* _tmp36_;
							SudokuCellView* _tmp37_;
							SudokuCellView* _tmp38_;
							SudokuCellView** _tmp39_;
							gint _tmp39__length1;
							gint _tmp39__length2;
							SudokuCellView* _tmp40_;
							SudokuCellView* _tmp41_;
							GtkGrid* _tmp42_;
							SudokuCellView* _tmp43_;
							_data8_ = g_slice_new0 (Block8Data);
							_data8_->_ref_count_ = 1;
							_data8_->_data7_ = block7_data_ref (_data7_);
							if (!_tmp26_) {
								gint _tmp27_;
								_tmp27_ = col;
								col = _tmp27_ + 1;
							}
							_tmp26_ = FALSE;
							_tmp28_ = _data7_->game->board;
							_tmp29_ = sudoku_board_get_cols (_tmp28_);
							_tmp30_ = _tmp29_;
							if (!(col < _tmp30_)) {
								block8_data_unref (_data8_);
								_data8_ = NULL;
								break;
							}
							_tmp31_ = sudoku_cell_view_new (row, col, &self->game);
							g_object_ref_sink (_tmp31_);
							cell = _tmp31_;
							_data8_->cell_row = row;
							_data8_->cell_col = col;
							_tmp33_ = cell;
							_tmp34_ = sudoku_cell_view_get_is_fixed (_tmp33_);
							_tmp35_ = _tmp34_;
							if (_tmp35_) {
								_tmp32_ = fixed_cell_color;
							} else {
								_tmp32_ = free_cell_color;
							}
							_tmp36_ = cell;
							sudoku_cell_view_set_background_color (_tmp36_, &_tmp32_);
							_tmp37_ = cell;
							g_signal_connect_data ((GtkWidget*) _tmp37_, "focus-in-event", (GCallback) _________lambda13__gtk_widget_focus_in_event, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
							_tmp38_ = cell;
							g_signal_connect_data ((GObject*) _tmp38_, "notify::value", (GCallback) _________lambda14__g_object_notify, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
							_tmp39_ = self->priv->cells;
							_tmp39__length1 = self->priv->cells_length1;
							_tmp39__length2 = self->priv->cells_length2;
							_tmp40_ = cell;
							_tmp41_ = _g_object_ref0 (_tmp40_);
							_g_object_unref0 (_tmp39_[(row * _tmp39__length2) + col]);
							_tmp39_[(row * _tmp39__length2) + col] = _tmp41_;
							_tmp42_ = self->priv->grid;
							_tmp43_ = cell;
							gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, col, row, 1, 1);
							_g_object_unref0 (cell);
							block8_data_unref (_data8_);
							_data8_ = NULL;
						}
					}
				}
			}
		}
	}
	_tmp44_ = self->priv->overlay;
	_tmp45_ = self->priv->drawing;
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
	_tmp46_ = self->priv->overlay;
	_tmp47_ = self->priv->grid;
	gtk_overlay_add_overlay (_tmp46_, (GtkWidget*) _tmp47_);
	_tmp48_ = self->priv->drawing;
	gtk_widget_show ((GtkWidget*) _tmp48_);
	_tmp49_ = self->priv->grid;
	gtk_widget_show_all ((GtkWidget*) _tmp49_);
	_tmp50_ = self->priv->overlay;
	gtk_widget_show ((GtkWidget*) _tmp50_);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return self;
}

SudokuView*
sudoku_view_new (SudokuGame* game)
{
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game);
}

static gboolean
sudoku_view_draw_board (SudokuView* self,
                        cairo_t* c)
{
	gint board_length = 0;
	GtkGrid* _tmp0_;
	gdouble tile_length = 0.0;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	SudokuGame* _tmp62_;
	gboolean _tmp63_;
	gboolean _tmp64_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_ = self->priv->grid;
	board_length = gtk_widget_get_allocated_width ((GtkWidget*) _tmp0_);
	_tmp1_ = self->game;
	_tmp2_ = _tmp1_->board;
	_tmp3_ = sudoku_board_get_cols (_tmp2_);
	_tmp4_ = _tmp3_;
	tile_length = ((gdouble) (board_length - 1)) / _tmp4_;
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
		cairo_translate (c, (gdouble) board_length, (gdouble) 0);
		cairo_scale (c, (gdouble) -1, (gdouble) 1);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = self->game;
				_tmp8_ = _tmp7_->board;
				_tmp9_ = sudoku_board_get_cols (_tmp8_);
				_tmp10_ = _tmp9_;
				if (!(i < _tmp10_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp11_ = FALSE;
						_tmp11_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							gint _tmp15_;
							gint _tmp16_;
							GdkRGBA background_color = {0};
							SudokuCellView** _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							SudokuCellView* _tmp18_;
							GdkRGBA _tmp19_ = {0};
							GdkRGBA _tmp20_;
							GdkRGBA _tmp21_;
							GdkRGBA _tmp22_;
							GdkRGBA _tmp23_;
							if (!_tmp11_) {
								gint _tmp12_;
								_tmp12_ = j;
								j = _tmp12_ + 1;
							}
							_tmp11_ = FALSE;
							_tmp13_ = self->game;
							_tmp14_ = _tmp13_->board;
							_tmp15_ = sudoku_board_get_cols (_tmp14_);
							_tmp16_ = _tmp15_;
							if (!(j < _tmp16_)) {
								break;
							}
							_tmp17_ = self->priv->cells;
							_tmp17__length1 = self->priv->cells_length1;
							_tmp17__length2 = self->priv->cells_length2;
							_tmp18_ = _tmp17_[(i * _tmp17__length2) + j];
							sudoku_cell_view_get_background_color (_tmp18_, &_tmp19_);
							_tmp20_ = _tmp19_;
							background_color = _tmp20_;
							_tmp21_ = background_color;
							_tmp22_ = background_color;
							_tmp23_ = background_color;
							cairo_set_source_rgb (c, _tmp21_.red, _tmp22_.green, _tmp23_.blue);
							cairo_rectangle (c, ((gint) (j * tile_length)) + 0.5, ((gint) (i * tile_length)) + 0.5, ((gint) ((j + 1) * tile_length)) + 0.5, ((gint) ((i + 1) * tile_length)) + 0.5);
							cairo_fill (c);
						}
					}
				}
			}
		}
	}
	cairo_set_line_width (c, (gdouble) 1);
	cairo_set_source_rgb (c, 0.6, 0.6, 0.6);
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp24_ = FALSE;
			_tmp24_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp26_;
				SudokuBoard* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				SudokuGame* _tmp30_;
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp24_ = FALSE;
				_tmp26_ = self->game;
				_tmp27_ = _tmp26_->board;
				_tmp28_ = sudoku_board_get_cols (_tmp27_);
				_tmp29_ = _tmp28_;
				if (!(i < _tmp29_)) {
					break;
				}
				_tmp30_ = self->game;
				_tmp31_ = _tmp30_->board;
				_tmp32_ = sudoku_board_get_block_cols (_tmp31_);
				_tmp33_ = _tmp32_;
				if ((i % _tmp33_) == 0) {
					continue;
				}
				cairo_move_to (c, ((gint) (i * tile_length)) + 0.5, (gdouble) 1);
				cairo_line_to (c, ((gint) (i * tile_length)) + 0.5, (gdouble) board_length);
			}
		}
	}
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp34_ = FALSE;
			_tmp34_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp36_;
				SudokuBoard* _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				SudokuGame* _tmp40_;
				SudokuBoard* _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				if (!_tmp34_) {
					gint _tmp35_;
					_tmp35_ = i;
					i = _tmp35_ + 1;
				}
				_tmp34_ = FALSE;
				_tmp36_ = self->game;
				_tmp37_ = _tmp36_->board;
				_tmp38_ = sudoku_board_get_cols (_tmp37_);
				_tmp39_ = _tmp38_;
				if (!(i < _tmp39_)) {
					break;
				}
				_tmp40_ = self->game;
				_tmp41_ = _tmp40_->board;
				_tmp42_ = sudoku_board_get_block_rows (_tmp41_);
				_tmp43_ = _tmp42_;
				if ((i % _tmp43_) == 0) {
					continue;
				}
				cairo_move_to (c, (gdouble) 1, ((gint) (i * tile_length)) + 0.5);
				cairo_line_to (c, (gdouble) board_length, ((gint) (i * tile_length)) + 0.5);
			}
		}
	}
	cairo_stroke (c);
	cairo_set_line_width (c, (gdouble) 2);
	cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp44_ = FALSE;
			_tmp44_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp49_;
				SudokuBoard* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				if (!_tmp44_) {
					SudokuGame* _tmp45_;
					SudokuBoard* _tmp46_;
					gint _tmp47_;
					gint _tmp48_;
					_tmp45_ = self->game;
					_tmp46_ = _tmp45_->board;
					_tmp47_ = sudoku_board_get_block_cols (_tmp46_);
					_tmp48_ = _tmp47_;
					i += _tmp48_;
				}
				_tmp44_ = FALSE;
				_tmp49_ = self->game;
				_tmp50_ = _tmp49_->board;
				_tmp51_ = sudoku_board_get_cols (_tmp50_);
				_tmp52_ = _tmp51_;
				if (!(i <= _tmp52_)) {
					break;
				}
				cairo_move_to (c, ((gint) (i * tile_length)) + 0.5, (gdouble) 0);
				cairo_line_to (c, ((gint) (i * tile_length)) + 0.5, (gdouble) board_length);
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp53_ = FALSE;
			_tmp53_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp58_;
				SudokuBoard* _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
				if (!_tmp53_) {
					SudokuGame* _tmp54_;
					SudokuBoard* _tmp55_;
					gint _tmp56_;
					gint _tmp57_;
					_tmp54_ = self->game;
					_tmp55_ = _tmp54_->board;
					_tmp56_ = sudoku_board_get_block_rows (_tmp55_);
					_tmp57_ = _tmp56_;
					i += _tmp57_;
				}
				_tmp53_ = FALSE;
				_tmp58_ = self->game;
				_tmp59_ = _tmp58_->board;
				_tmp60_ = sudoku_board_get_cols (_tmp59_);
				_tmp61_ = _tmp60_;
				if (!(i <= _tmp61_)) {
					break;
				}
				cairo_move_to (c, (gdouble) 0, ((gint) (i * tile_length)) + 0.5);
				cairo_line_to (c, (gdouble) board_length, ((gint) (i * tile_length)) + 0.5);
			}
		}
	}
	cairo_stroke (c);
	_tmp62_ = self->game;
	_tmp63_ = sudoku_game_get_paused (_tmp62_);
	_tmp64_ = _tmp63_;
	if (_tmp64_) {
		gchar* text = NULL;
		gchar* _tmp65_;
		cairo_text_extents_t extents = {0};
		const gchar* _tmp66_;
		cairo_text_extents_t _tmp67_ = {0};
		cairo_text_extents_t _tmp68_;
		cairo_text_extents_t _tmp69_;
		const gchar* _tmp70_;
		cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
		cairo_paint (c);
		cairo_select_font_face (c, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
		cairo_set_font_size (c, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
		_tmp65_ = g_strdup (_ ("Paused"));
		text = _tmp65_;
		_tmp66_ = text;
		cairo_text_extents (c, _tmp66_, &_tmp67_);
		extents = _tmp67_;
		_tmp68_ = extents;
		_tmp69_ = extents;
		cairo_move_to (c, (board_length / 2.0) - (_tmp68_.width / 2.0), (board_length / 2.0) + (_tmp69_.height / 2.0));
		cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
		_tmp70_ = text;
		cairo_show_text (c, _tmp70_);
		_g_free0 (text);
	}
	result = FALSE;
	return result;
}

void
sudoku_view_clear (SudokuView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_view_clear (_tmp13_);
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_hide_popovers (SudokuView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_view_hide_both_popovers (_tmp13_);
						}
					}
				}
			}
		}
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_warnings;
	return result;
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_warnings = value;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_view_set_show_warnings (_tmp13_, self->priv->_show_warnings);
						}
					}
				}
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_possibilities;
	return result;
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_possibilities = value;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->game;
				_tmp3_ = _tmp2_->board;
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCellView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCellView* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = self->game;
							_tmp9_ = _tmp8_->board;
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
							_tmp11_ = _tmp10_;
							if (!(j < _tmp11_)) {
								break;
							}
							_tmp12_ = self->priv->cells;
							_tmp12__length1 = self->priv->cells_length1;
							_tmp12__length2 = self->priv->cells_length2;
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
							sudoku_cell_view_set_show_possibilities (_tmp13_, value);
						}
					}
				}
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlighter;
	return result;
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_highlighter = value;
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
	self->priv = sudoku_view_get_instance_private (self);
	self->priv->previous_board_broken_state = FALSE;
	self->priv->selected_row = 0;
	self->priv->selected_col = 0;
	self->priv->_show_warnings = FALSE;
	self->priv->_show_possibilities = FALSE;
	self->priv->_highlighter = FALSE;
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
	_g_object_unref0 (self->game);
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_object_unref0 (self->priv->overlay);
	_g_object_unref0 (self->priv->drawing);
	_g_object_unref0 (self->priv->grid);
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (gtk_aspect_frame_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_view_type_id__volatile)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__volatile, sudoku_view_type_id);
	}
	return sudoku_view_type_id__volatile;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
	switch (property_id) {
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
		break;
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
		break;
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
	switch (property_id) {
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
		break;
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

